Bug 830336 - db deadlock return should not log error
Summary: db deadlock return should not log error
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: 389-ds-base
Version: 6.4
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: rc
: ---
Assignee: Rich Megginson
QA Contact: Sankar Ramalingam
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-06-08 21:15 UTC by Nathan Kinder
Modified: 2013-02-21 08:17 UTC (History)
2 users (show)

Fixed In Version: 389-ds-base-1.2.11.12-1.el6
Doc Type: Bug Fix
Doc Text:
Cause: The directory server is under a heavy read and write load, and an update request is processed. Consequence: An error message appears in the errors log: "entryrdn-index - _entryrdn_put_data: Adding the parent link (XXX) failed: DB_LOCK_DEADLOCK: Locker killed to resolve a deadlock (-30994)". Or other similar DB_LOCK_DEADLOCK error messages. Fix: Deadlocks are quite normal under concurrent write loads. The fix is to ensure deadlocks are handled properly (by retrying the transaction) and not to log these messages since they are not errors. Result: Directory Server can sustain a heavy write load without logging deadlock messages to the errors log.
Clone Of:
Environment:
Last Closed: 2013-02-21 08:17:27 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2013:0503 normal SHIPPED_LIVE Moderate: 389-ds-base security, bug fix, and enhancement update 2013-02-21 08:18:44 UTC

Description Nathan Kinder 2012-06-08 21:15:12 UTC
This bug is created as a clone of upstream ticket:
https://fedorahosted.org/389/ticket/345

When entryrdn gets a deadlock, it should not report an error at the default log level e.g.

[15/Apr/2012:07:33:33 -0400] entryrdn-index - _entryrdn_put_data: Adding the
parent link (P28354) failed: DB_LOCK_DEADLOCK: Locker killed to resolve a
deadlock (-30994)

It should log this at the TRACE log level.

Comment 1 Jenny Severance 2012-06-19 16:43:42 UTC
Please add steps to reproduce this dead lock.

Comment 2 Rich Megginson 2012-07-07 14:30:19 UTC
Covered by the new test multi_plugin - the stress test
testcases/DS/6.0/multi_plugin
------------------------------------------------------------------------
r6706 | rmeggins@REDHAT.COM | 2012-07-07 08:24:23 -0600 (Sat, 07 Jul 2012) | 16 lines

Add multi_plugin test suite
This test enables and configures multiple plugins in the style
of ipa.  The stress version of this test will enable the 
TXN_TESTING in the server which will exercise the txn deadlock
and retry code paths in the server.
Tickets covered by this test:
Ticket #345 - db deadlock return should not log error
Ticket #387 - managed entry sometimes doesn't delete the managed entry
Ticket #360 - ldapmodify returns Operations error
Ticket #335 - transaction retries need to be cache aware
Bugs covered by this test:
830336 db deadlock return should not log error
830343 managed entry sometimes doesn't delete the managed entry
833218 ldapmodify returns Operations error
833202 transaction retries need to be cache aware


Steps to reproduce
1) run the multi_plugin stress tests
2) make sure no DB_LOCK_DEADLOCK messages are in the errors log

Comment 4 Ján Rusnačko 2013-01-29 11:31:58 UTC
On RHEL 6.4 Snapshot 5 with 389-ds-base-1.2.11.15-11.el6.x86_64:

multi_plugin startup 	100% (1/1)
multi_plugin run 	100% (6/6)
multi_plugin cleanup 	100% (1/1)

No errors in log.

Verified.

Comment 6 errata-xmlrpc 2013-02-21 08:17:27 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-0503.html


Note You need to log in before you can comment on or make changes to this bug.